#ifndef _manipulator_h_
#define _manipulator_h_

#include <ygTransform.h>

#ifdef _WIN32
#include <windows.h>
#else
#ifndef APIENTRY
#define APIENTRY
#endif

#define YG_manipulator_MODULE_DLL_API 
#endif

class YG_manipulator_MODULE_DLL_API manipulator : public ygTransform
{
    public:
     manipulator(const char *name, bool master=true);
     ~manipulator(void);
     virtual void reset(void);
     virtual void message(const ygMessage &msg);
     virtual void app(void);
     void grab(void);
     void drop(void);
    private:
     ygNode* transform;
     ygString nodeName;
     ygNode* node;
     ygString grabName;
     ygNode* grab_;
     int mode;
     int axis;
     int currAxis;
     pfVec3 handle;
     pfVec3 parentHandle;
     pfMatrix handleDiff;
     pfMatrix lastMatrix;
};

#endif
