#ifndef _material_h_
#define _material_h_

#include "ygNode.h"


#ifdef _WIN32
#include <windows.h>
#else
#ifndef APIENTRY
#define APIENTRY
#endif

#define YG_material_MODULE_DLL_API 
#endif

class YG_material_MODULE_DLL_API material : public ygNode
    {
    public:
     material(const char* name,bool master=true);
     ~material(void);
     virtual void reset(void);
     virtual void message(const ygMessage&);
     virtual void app(void);
    private:
     void setGSetList(pfNode*);
     void setColor(int,float,float,float);
     void setAlpha(float);
     void setShininess(float);
     pfList* gSetList;
     pfVec3 ambient;
     pfVec3 diffuse;
     pfVec3 emission;
     pfVec3 specular;
     float shininess;
     float alpha;
     uint changed;
    };

#endif
