#ifndef _mirror_h_
#define _mirror_h_

#include <Performer/pf/pfDCS.h>
#include <set>
#include <vector>
#include "ygSpace.h"
#include "ygTransform.h"

using namespace std;


#ifdef _WIN32
#include <windows.h>
#else
#ifndef APIENTRY
#define APIENTRY
#endif

#define YG_mirror_MODULE_DLL_API 
#endif

class YG_mirror_MODULE_DLL_API mirror : public ygSpace
    {
    public:
     static int preDrawFunc(pfTraverser*,void*);
     static int postDrawFunc(pfTraverser*,void*);
     mirror(const char* name,bool master=true);
     ~mirror(void);
     virtual void reset(void);
     virtual void message(const ygMessage&);
     virtual void app(void);
    private:
     void setAxis(void);
     void addSubject(const ygString&);
     set<ygUser*> prevInside;
     vector<ygNode*> subjects;
     pfDCS* dcsUsers;
     pfMatrix reflection;
     int axis;
     ygString subjectList;
    };


#endif
