#ifndef _pointMover_h_
#define _pointMover_h_

#ifndef WIN32
#include <vector.h>
#else
#include <vector>
using namespace std;
#endif

#include <ygTransform.h>


#ifdef _WIN32
#include <windows.h>
#else
#ifndef APIENTRY
#define APIENTRY
#endif

#define YG_pointMover_MODULE_DLL_API 
#endif

class YG_pointMover_MODULE_DLL_API pointMover : public ygTransform
    {
    public:
     pointMover(const char* name,bool master=true);
     ~pointMover(void);
     virtual void reset(void);
     virtual void message(const ygMessage&);
         void loadPath(const ygString& file);
         void interpolate(float t);
    private:
     typedef struct
        {
        pfVec3 pos;
        pfQuat quat;
        } ygPosQuat;
     float position;
     ygString filename;
     vector<ygPosQuat*> points;
     vector<float> pointList;
    };


#endif
