#ifndef _rain_h_
#define _rain_h_

#include "ygNode.h"


#ifdef _WIN32
#include <windows.h>
#else
#ifndef APIENTRY
#define APIENTRY
#endif

#define YG_rain_MODULE_DLL_API 
#endif

#ifdef WIN32
#include <stdlib.h>
#include <time.h>

#define drand48()   ((double) ((double) rand() / (double) RAND_MAX))
#endif

class YG_rain_MODULE_DLL_API rain : public ygNode
    {
    public:
     rain(const char* name,bool master=true);
     virtual void reset(void);
     virtual void message(const ygMessage&);
     virtual void app(void);
     inline float randomVal(float min, float max) {return (min + drand48()*(max - min));};
    private:
     pfVec3* rain_;
     pfCoord range_;
     float ground_;
     float speed_;
     int count_;
     void createGeode(void);
     pfGeode* makeCylinder(void);
    };

#endif
