#ifndef _smoke_h_
#define _smoke_h_

#include "ygNode.h"
#include <Performer/pfutil.h>

typedef struct _smokeData smokeData_t;


#ifdef _WIN32
#include <windows.h>
#else
#ifndef APIENTRY
#define APIENTRY
#endif

#define YG_smoke_MODULE_DLL_API 
#endif

class YG_smoke_MODULE_DLL_API smoke : public ygNode
    {
    public:
     smoke(const char* name,bool master=true);
     ~smoke(void);
     virtual void reset(void);
     virtual void message(const ygMessage&);
     virtual void app(void);
     static int smokePreDraw(pfTraverser*,void*);
     static int smokePostDraw(pfTraverser*,void*);
    private:
     void createSmoke(void);
     pfVec2 velocity;
     pfVec3 density;
     pfCoord color;
     pfuSmoke* smoke_;
     int type_;
     bool active;     
     smokeData_t* data_;
    };

#endif
