#ifndef _surface_h_
#define _surface_h_

#include <Performer/pf/pfGroup.h>
#include <Performer/pf/pfGeode.h>
#include <Performer/pr/pfGeoSet.h>
#include <Performer/pr/pfMaterial.h> 
#include <Performer/pr/pfTexture.h>
#include <Performer/pr.h>
#include <ygGeometry.h>


#ifdef _WIN32
#include <windows.h>
#else
#ifndef APIENTRY
#define APIENTRY
#endif

#define YG_surface_MODULE_DLL_API 
#endif

class YG_surface_MODULE_DLL_API surface : public ygGeometry
    {
    public:
     surface(const char* name,bool master=true);
     ~surface(void);
     virtual void reset(void);
     virtual void message(const ygMessage&);
    protected:
     int xSize_;
     int ySize_;
     int lastXSize_;
     int lastYSize_;
     ygString textureFile;
     pfMaterial* mat;
     pfTexture* texture;
     pfGeode* geode;
     pfGeoState* gstate;
     pfGeoSet* gset;
     ushort* ilist;
     pfVec2* texCoords;
     pfVec3* verts;
     pfVec3* norms;
     pfVec4* colors;
     void setTexture(const ygString&);
     void createGeometry(int,int);
    private:
     ygNode* transform;
     void createTransform(void);
    };

#endif
