#ifndef _textureTransform_h_
#define _textureTransform_h_

#include <Performer/pf/pfGeode.h>
#include <Performer/pr/pfGeoState.h>
#include "ygObject.h"


#ifdef _WIN32
#include <windows.h>
#else
#ifndef APIENTRY
#define APIENTRY
#endif

#define YG_textureTransform_MODULE_DLL_API 
#endif

class YG_textureTransform_MODULE_DLL_API textureTransform : public ygNode
    {
    public:
     textureTransform(const char* name,bool master=true);
     ~textureTransform(void);
     virtual void reset(void);
     virtual void message(const ygMessage&);
     virtual void app(void);
    private:
     void setMatrix(void);
     pfGeoState* gstate;
     pfMatrix* matrix;
     pfVec2 startPosition;
     pfVec2 position;
     pfVec2 orientation;
     pfVec2 size;
     void setTexMat(pfNode*);
     void setGeosetTexMat(pfGeoSet*);
    };

#endif
