#ifndef _ygTokenStream_h_
#define _ygTokenStream_h_

#include <stdio.h>
#include <stack>
#include "ygString.h"

#include "ygDLL.h"

#ifdef WIN32
#ifdef _MSC_VER
#pragma warning(push)
#pragma warning(disable: 4251 4800 4267 4018)
#endif // _MSC_VER
#endif

class YG_DLL_API ygTokenStream
    {
    public:
     ygTokenStream(const ygString&,bool preprocess=true);
     ~ygTokenStream(void);
     bool next(ygString &string);
     const ygString& filename(void) const { return filename_; }
     int linenumber(void) const { return lineNumber_; }
     void pushback(const ygString& string);
     ygString* nextComment(void);
    private:
     bool getNextLine(void);
     bool readNextToken(ygString& token);
     int nextChar(void);
     void pushbackChar(int c);
     ygString filename_;
     FILE *fp_;
     char* linebuf_;
     char* linebufptr_;
     int lineNumber_;
     int lineSize_;
     bool comment_;
     std::stack<ygString*> tokenStack_;
     std::stack<int> charStack_;
     std::stack<ygString*> commentStack_;
     bool noPreprocessor_;
    };

#if defined(WIN32) && defined(_MSC_VER)
#pragma warning(pop)
#endif

#endif
